//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_color3  clrDeepSkyBlue
#property indicator_color4  clrSandyBrown
#property indicator_color5  clrSandyBrown
#property indicator_color6  clrDeepSkyBlue
#property indicator_color7  clrSandyBrown
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  3
#property indicator_width6  1
#property indicator_width7  1
#property strict

//
//
//
//
//

#define _fltPrc 0x01
#define _fltVal 0x10
enum enFilterWhat
{
   flt_01=_fltPrc,        // Filter the prices
   flt_02=_fltVal,        // Filter the ema value
   flt_03=_fltPrc+_fltVal // Filter prices and the ema value
};
#define _disLin 0x001
#define _disHis 0x010
#define _disDot 0x100
enum enDisplay
{
   dis_01=_disLin,                // Display line
   dis_02=_disHis,                // Display colored bars
   dis_07=_disDot,                // Display dots
   dis_03=_disLin+_disHis,        // Display colored lines and bars
   dis_04=_disLin+_disDot,        // Display lines with dots
   dis_05=_disHis+_disDot,        // Display colored bars with dots
   dis_06=_disLin+_disDot+_disHis // Display all
};

extern ENUM_TIMEFRAMES    TimeFrame          = PERIOD_CURRENT;  // Time frame to use
extern int                Length             = 14;              // Calculation length
extern ENUM_APPLIED_PRICE Price              = PRICE_CLOSE;     // Price to use
extern double             Lambda             = 5;               // Lambda
extern double             Filter             = 0;               // Filter to use for filtering (<=0 - no filtering)
extern int                FilterPeriod       = 0;               // Filter period (0<= use ema period)
extern enFilterWhat       FilterOn           = _fltVal;         // Apply filter to :
extern bool               alertsOn           = false;           // Turn alerts on?
extern bool               alertsOnCurrent    = true;            // Alerts on current (still opened) bar?
extern bool               alertsMessage      = true;            // Alerts should show pop-up message?
extern bool               alertsSound        = false;           // Alerts should play a sound?
extern bool               alertsEmail        = false;           // Alerts should send email?
extern bool               alertsPushNotif    = false;           // Alerts should send push notification?
extern enDisplay          DisplayType        = _disLin;         // Display type
extern int                LinesWidth         = 3;               // Lines width (when lines are included in display)
extern int                BarsWidth          = 1;               // Bars width (when bars are included in display)
extern int                ArrowCodeUp        = 159;             // Arrow code up
extern int                ArrowCodeDn        = 159;             // Arrow code down
extern double             ArrowGapUp         = 0.5;             // Gap for arrow up        
extern double             ArrowGapDn         = 0.5;             // Gap for arrow down
extern bool               Interpolate        = true;            // Interpolate in multi time frame mode

//
//
//
//
//

double mom[];
double rema[];
double remda[];
double remdb[];
double slope[];
double histou[];
double histod[];
double arrowu[];
double arrowd[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      int lstyle = ((DisplayType&_disLin)!=0) ? DRAW_LINE      : DRAW_NONE;
      int hstyle = ((DisplayType&_disHis)!=0) ? DRAW_HISTOGRAM : DRAW_NONE;
      int astyle = ((DisplayType&_disDot)!=0) ? DRAW_ARROW     : DRAW_NONE;
         SetIndexBuffer(0,histou);  SetIndexStyle(0,hstyle,EMPTY,BarsWidth);
         SetIndexBuffer(1,histod);  SetIndexStyle(1,hstyle,EMPTY,BarsWidth);
         SetIndexBuffer(2,rema);    SetIndexStyle(2,lstyle,EMPTY,LinesWidth);
         SetIndexBuffer(3,remda);   SetIndexStyle(3,lstyle,EMPTY,LinesWidth);
         SetIndexBuffer(4,remdb);   SetIndexStyle(4,lstyle,EMPTY,LinesWidth);
         SetIndexBuffer(5,arrowu);  SetIndexStyle(5,astyle); SetIndexArrow(5,ArrowCodeUp);
         SetIndexBuffer(6,arrowd);  SetIndexStyle(6,astyle); SetIndexArrow(6,ArrowCodeDn);
         SetIndexBuffer(7,slope);
            indicatorFileName   = WindowExpertName();
            returnBars          = TimeFrame==-99;
            TimeFrame           = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" Regularized ema ("+(string)Length+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { histou[0] = limit+1; return(0); }
         if (TimeFrame!=Period())
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            if (slope[limit]==-1) CleanPoint(limit,remda,remdb);
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
                  rema[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,Lambda,Filter,FilterPeriod,FilterOn,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPushNotif,2,y);
                  remda[i]  = EMPTY_VALUE;
                  remdb[i]  = EMPTY_VALUE;
                  arrowu[i] = EMPTY_VALUE;
                  arrowd[i] = EMPTY_VALUE;
                  histou[i] = EMPTY_VALUE;
                  histod[i] = EMPTY_VALUE;
                  slope[i]  = (i<Bars-1) ? (rema[i]>rema[i+1]) ? 1 :  (rema[i]< rema[i+1]) ? -1 : slope[i+1] : 0;
                     if (slope[i]==-1) { histou[i] = Low[i]; histod[i] = High[i]; }
                     if (slope[i]== 1) { histod[i] = Low[i]; histou[i] = High[i]; }
                     if (i<Bars-1 && slope[i]!=slope[i+1])
                     {
                        if (slope[i] ==  1) arrowu[i] = MathMin(rema[i],Low[i] )-iATR(NULL,0,15,i)*ArrowGapUp;
                        if (slope[i] == -1) arrowd[i] = MathMax(rema[i],High[i])+iATR(NULL,0,15,i)*ArrowGapDn;
                     }
                     
                     //
                     //
                     //
                     //
                     //
                     
                      if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

                     //
                     //
                     //
                     //
                     //

                     int n,s; datetime time = iTime(NULL,TimeFrame,y);
                        for(n = 1; i+n<Bars && Time[i+n] >= time; n++) continue;
                        for(s = 1; i+n<Bars && i+s<Bars && s<n; s++) 
  	                        rema[i+s] = rema[i] + (rema[i+n] - rema[i])* s/n;
            }       
   	      for(int i=limit; i>=0; i--) if (slope[i]==-1) PlotPoint(i,remda,remdb,rema);
            return(0);
         }

   //
   //
   //
   //
   //

   int    tperiod = (FilterPeriod>0) ? FilterPeriod : Length;
   double pfilter = ((FilterOn&_fltPrc)!=0) ? Filter : 0;
   double vfilter = ((FilterOn&_fltVal)!=0) ? Filter : 0;
   double alpha   = 2.0 / (1.0+Length);      
   double regf1   = (1.0+Lambda*2.0);
   double regf2   = (1.0+Lambda);
   if (slope[limit]==-1) CleanPoint(limit,remda,remdb);
   for(int i=limit; i>=0; i--) 
   {
      double price = iFilter(iMA(NULL,0,1,0,MODE_SMA,Price,i),pfilter,tperiod,i,0);
             rema[i]   = (i<Bars-2) ? iFilter((regf1*rema[i+1]+alpha*(price-rema[i+1])-Lambda*rema[i+2])/regf2,vfilter,tperiod,i,1) : price;
             slope[i]  = (i<Bars-1) ? (rema[i]>rema[i+1]) ? 1 :  (rema[i]< rema[i+1]) ? -1 : slope[i+1] : 0;
             remda[i]  = EMPTY_VALUE;
             remdb[i]  = EMPTY_VALUE;
             arrowu[i] = EMPTY_VALUE;
             arrowd[i] = EMPTY_VALUE;
             histou[i] = EMPTY_VALUE;
             histod[i] = EMPTY_VALUE;
               if (slope[i]==-1) { histou[i] = Low[i]; histod[i] = High[i]; }
               if (slope[i]== 1) { histod[i] = Low[i]; histou[i] = High[i]; }
               if (i<Bars-1 && slope[i]!=slope[i+1])
               {
                  if (slope[i] ==  1) arrowu[i] = MathMin(rema[i],Low[i] )-iATR(NULL,0,15,i)*ArrowGapUp;
                  if (slope[i] == -1) arrowd[i] = MathMax(rema[i],High[i])+iATR(NULL,0,15,i)*ArrowGapDn;
               }
               if (slope[i]==-1) PlotPoint(i,remda,remdb,rema);
   }  
   manageAlerts(); 
   return(0);
}


//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

#define filterInstances 2
double workFil[][filterInstances*3];

#define _fchange 0
#define _fachang 1
#define _fprice  2

double iFilter(double tprice, double filter, int period, int i, int instanceNo=0)
{
   if (filter<=0) return(tprice);
   if (ArrayRange(workFil,0)!= Bars) ArrayResize(workFil,Bars); i = Bars-i-1; instanceNo*=3;
   
   //
   //
   //
   //
   //
   
   workFil[i][instanceNo+_fprice]  = tprice; if (i<1) return(tprice);
   workFil[i][instanceNo+_fchange] = MathAbs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]);
   workFil[i][instanceNo+_fachang] = workFil[i][instanceNo+_fchange];

   for (int k=1; k<period && (i-k)>=0; k++) workFil[i][instanceNo+_fachang] += workFil[i-k][instanceNo+_fchange];
                                            workFil[i][instanceNo+_fachang] /= period;
    
   double stddev = 0; for (int k=0;  k<period && (i-k)>=0; k++) stddev += MathPow(workFil[i-k][instanceNo+_fchange]-workFil[i-k][instanceNo+_fachang],2);
          stddev = MathSqrt(stddev/(double)period); 
   double filtev = filter * stddev;
   if( MathAbs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]) < filtev ) workFil[i][instanceNo+_fprice]=workFil[i-1][instanceNo+_fprice];
        return(workFil[i][instanceNo+_fprice]);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar]== 1) doAlert(whichBar,"slope changed to up");
         if (slope[whichBar]==-1) doAlert(whichBar,"slope changed to down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = timeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" regularized ema "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," regularized ema "),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," regularized ema "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}